# This file is an example script for using the policy generator,
# Created by Mohammad Hassan, June 2002.

# source the generators code (this is not part of the release yet)
source topo-gen.tcl
source agent-gen.tcl
source route-gen.tcl
source policy-gen.tcl

# setup the files that will contain the scripts generated
set topofile topo1.tcl
set agentfile agent1.tcl
set routefile route1.tcl
set policyfile policy1.tcl

# if we want to generate a hierarchical topology, inorder
# to be able to define end point distribution. valid only for 
# transit-stub topologies .
set hier_flag 1 

# we remove the agentfile, to start afresh... the agentfile is
# opened in append mode and previous runs may cause problems
if { [file exists $agentfile] } {
	catch { [exec rm $agentfile] }
}

topology -outfile $topofile -type mtransit_stub -nor 2 -ra1 20 -po1 0.2 -ra2 300 -po2 0.8 -ra3 500


agents -outfile $agentfile -transport TCP/Reno -src FTP -sink TCPSink/DelAck -num 5 -srcstub 1-7 -deststub 8-14 -start 1-3 -stop 9-11

agents -outfile $agentfile -transport TCP/Reno -src FTP -sink TCPSink/DelAck -num 5 -srcstub 8-14 -deststub 1-7 -start 1-3 -stop 9-11

agents -outfile $agentfile -transport TCP/Reno -src FTP -sink TCPSink/DelAck -num 5 -srcstub 1 -deststub 8 -start 1-3 -stop 9-11
agents -outfile $agentfile -transport TCP/Reno -src FTP -sink TCPSink/DelAck -num 5 -srcstub 1 -deststub 8 -start 1-3 -stop 9-11
agents -outfile $agentfile -transport TCP/Reno -src FTP -sink TCPSink/DelAck -num 5 -srcstub 1 -deststub 8 -start 1-3 -stop 9-11
agents -outfile $agentfile -transport TCP/Reno -src FTP -sink TCPSink/DelAck -num 5 -srcstub 1 -deststub 8 -start 1-3 -stop 9-11
agents -outfile $agentfile -transport TCP/Reno -src FTP -sink TCPSink/DelAck -num 5 -srcstub 1 -deststub 8 -start 1-3 -stop 9-11
agents -outfile $agentfile -transport TCP/Reno -src FTP -sink TCPSink/DelAck -num 5 -srcstub 1 -deststub 8 -start 1-3 -stop 9-11



mark-end $agentfile

# put policy parametres

policy -outfile $policyfile -q1min 10 -q1max 20 -q1prob 0.5

