

Simulator instproc add-control {n1 n2 bw} {


    set link12 [$self link $n1 $n2]
    set link21 [$self link $n2 $n1]

    # admission control module
    $link12 set paramadc_ [new ADC/Param]
    $link21 set paramadc_ [new ADC/Param]
    [$link12 set paramadc_] set bandwidth_ $bw
    [$link21 set paramadc_] set bandwidth_ $bw
}

#implement get-bw function required for qos routing

# available bw = total bandwith * utilization - reserved bandwith
SimpleLink instproc get-bw {} {
    $self instvar paramadc_
    if {![info exists paramadc_]} {
	return 0
    }
    set bandwidth_ [bw_parse [$paramadc_ set bandwidth_]]
      return [expr $bandwidth_ * \
  		[$paramadc_ set utilization_] - \
  		[$paramadc_ set oresv_rate_] ]
}

# creates a session between $self and $dest of bandwith bw with fid $fid
# bind agaent $agnt to that session.
# 1. get-explicit-route
# 2. query admission control module along the path and make reservations
# 3. install cbq classes for that fid with that bandwith
# 
# in actual networks, steps 2 and 3 would have to be carried by a 
# signalling agent

Node instproc create-session {dest bw fid agnt} {
    puts "hereeeeeee\n"
    $self instvar src_agent_

    set rt [$self get-module "QOSPF"]


    #get explicit-route

    set eroute [$rt get-explicit-route $dest $bw]

    if {![llength $eroute]} {
	puts "create session $bw $fid [$self id] - [$dest id] unsuccessful: bandwidth not available"
	$agnt set class_ 0
	return 0
    }

    
    #ok, now start making reservations along the path

    set sim [Simulator instance]

    set node1 $self

    set success 1 ;#whether reservation was successful
    set nlist "" ;#list of nodes where rollback has to be done in case

    puts "eroute = $eroute"

    foreach i $eroute {
	#get node from id
	set node2 [$sim get-node-by-id $i]
	#get link connecting node1 and node2
	set link [$sim link $node1 $node2]
	#get adc on them FIXME check whether it has adc
	set adc [$link set paramadc_]
	#reserve bandwith on link
	set ret [$adc admit_flow 0 $bw 0]
	#if ret false, rollback FIXME verify this
	if {!$ret} {
	    set success 0 ;#oops, we have to rollback
	    set rnode1 $self
	    foreach j $nlist {
		set rnode2 [$sim get-node-by-id $j]
		set rlink [$sim link $rnode1 $rnode2]
		set radc [$rlink set paramadc_]
		$radc rej_action 0 $bw 0
		set rnode1 $rnode2
	    }
	    break
	}
	lappend nlist $node2
	set node1 $node2
    } 
    
    if {!$success} {
	puts "create session $bw $fid [$self id] - [$dest id] unsuccessful: reservation unsuccessful"
	return 0 ;#sorry, failed to reserve
    }
    set node1 $self


    $rt bw-changed

    foreach i $eroute {
	#get node from id
	set node2 [$sim get-node-by-id $i]


	set nrt2 [$node2 get-module "QOSPF"]

	#get link connecting node1 and node2
	set link [$sim link $node1 $node2]
	$nrt2 bw-changed
	set adc [$link set paramadc_]
	set ratio [expr [bw_parse $bw]/[bw_parse [$adc set bandwidth_]]]
	set node1 $node2
    } 

    #setup source routing

    $agnt set class_ $fid
    $agnt target $src_agent_

    eval "$src_agent_ install_connection $fid [$self id] [$dest id] [$self id] $eroute"
    
    puts "create session $bw $fid [$self id] - [$dest id] successful"
    return 1

}


#---------------------------------------------------------------------------
#---------------------------------------------------------------------------




 

